PLASMA 2.8.0 PLASMA - Parallel Linear Algebra for Scalable Multi-core Architectures

- Main Page
- Modules
- Data Types List

int CORE_cttqrt | ( | int | M,
|  | int | N,
|  | int | IB,
|  | PLASMA_Complex32_t * | A1,
|  | int | LDA1,
|  | PLASMA_Complex32_t * | A2,
|  | int | LDA2,
|  | PLASMA_Complex32_t * | T,
|  | int | LDT,
|  | PLASMA_Complex32_t * | TAU,
|  | PLASMA_Complex32_t * | WORK
| ) |  |

CORE_cttqrt computes a QR factorization of a rectangular matrix formed by coupling a complex N-by-N upper triangular tile A1 on top of a complex M-by-N upper trapezoidal tile A2:

| A1 | = Q * R | A2 |

The tile Q is represented as a product of elementary reflectors

Q = H(1) H(2) . . . H(k), where k = min(M,N).

Each H(i) has the form

H(i) = I - tau * v * v'

where tau is a complex scalar, and v is a complex vector with v(1:i-1) = 0 and v(i) = 1; v(i+1:m) is stored on exit in A2(1:m,i), and tau in TAU(i).

Parameters

  [in] | M | The number of rows of the tile A2. M >= 0.
  [in] | N | The number of columns of the tile A1 and A2. N >= 0.
  [in] | IB | The inner-blocking size. IB >= 0.
  [in,out] | A1 | On entry, the N-by-N tile A1. On exit, the elements on and above the diagonal of the array contain the N-by-N upper trapezoidal tile R; the elements below the diagonal are not referenced.
  [in] | LDA1 | The leading dimension of the array A1. LDA1 >= max(1,N).
  [in,out] | A2 | On entry, the M-by-N upper triangular tile A2. On exit, the elements on and above the diagonal of the array with the array TAU, represent the unitary tile Q as a product of elementary reflectors (see Further Details).
  [in] | LDA2 | The leading dimension of the array A2. LDA2 >= max(1,M).
  [out] | T | The IB-by-N triangular factor T of the block reflector. T is upper triangular by block (economic storage); The rest of the array is not referenced.
  [in] | LDT | The leading dimension of the array T. LDT >= IB.
  [out] | TAU | The scalar factors of the elementary reflectors (see Further Details).
  [in,out] | WORK |

Returns

Return values

  PLASMA_SUCCESS | successful exit
  <0 | if -i, the i-th argument had an illegal value